#ifndef _WINAPI_H
#define _WINAPI_H

#include <windows.h>
#include <Wininet.h>
#include <ShlObj.h>

typedef HMODULE (WINAPI *LOADLIBRARYA)(__in LPSTR lpFileName);
typedef LOADLIBRARYA *PLOADLIBRARYA;
typedef HMODULE (WINAPI *LOADLIBRARYW)(__in LPWSTR lpFileName);
typedef LOADLIBRARYW *PLOADLIBRARYW;
typedef HMODULE (WINAPI *GETPROCADDRESS)(__in HMODULE hModule, __in LPSTR lpProcName);
typedef GETPROCADDRESS *PGETPROCADDRESS;

typedef LPVOID (WINAPI *VIRTUALALLOC)(__in LPVOID lpAddress, __in SIZE_T dwSize, __in DWORD flAllocationType, __in DWORD flProtect);
typedef BOOL (WINAPI *VIRTUALPROTECT)(__in LPVOID lpAddress, __in SIZE_T dwSize, __in DWORD flNewProtect, __out PDWORD lpflOldProtect);

typedef HMODULE(WINAPI *GETMODULEHANDLE)(LPCTSTR lpModuleName);

typedef VOID (WINAPI *EXITTHREAD)(__in  DWORD dwExitCode);
typedef VOID (WINAPI *EXITPROCESS)(__in DWORD uExitReason);
typedef DWORD (WINAPI *GETSHORTPATHNAMEW)(__in LPWSTR lpszLongPath, __in LPWSTR lpszShortPath, __in DWORD cchBuffer);
typedef DWORD (WINAPI *GETMODULEFILENAMEW)(__in HMODULE hModule, __out LPWSTR lpFilename, __in DWORD nSize);
typedef BOOL (WINAPI *SHGETSPECIALFOLDERPATHW)(__in HWND hwndOwner, __out LPWSTR lpszPath, __in int csidl, __in BOOL fCreate);
typedef DWORD (WINAPI *GETFILEATTRIBUTESA)(__in LPSTR strFileName);
typedef BOOL (WINAPI *DELETEFILEA)(__in LPSTR lpFileName);
typedef HINTERNET (WINAPI *INTERNETOPENA)(__in LPSTR lpszAgent, __in DWORD dwAccessType, __in LPSTR lpszProxyName, __in LPSTR lpszProxyBypass, __in DWORD dwFlags);
typedef HINTERNET (WINAPI *INTERNETOPENURLA)(__in HINTERNET hInternet, __in LPSTR lpszUrl, __in LPSTR lpszHeaders,  __in DWORD dwHeadersLength, __in DWORD dwFlags, __in DWORD_PTR dwContext);
typedef BOOL (WINAPI *HTTPQUERYINFOA)(__in HINTERNET hRequest, __in DWORD dwInfoLevel, __inout LPVOID lpvBuffer, __inout LPDWORD lpdwBufferLength, __inout LPDWORD lpdwIndex);
typedef BOOL (WINAPI *INTERNETREADFILEEXA)(__in HINTERNET hFile, __in LPINTERNET_BUFFERS lpBuffersOut, __in DWORD dwFlags, __in DWORD dwContext);
typedef HANDLE (WINAPI *CREATEFILEA)(__in LPSTR lpFileName, __in DWORD dwDesiredAccess, __in DWORD dwShareMode, __in LPSECURITY_ATTRIBUTES lpSecurityAttributes, __in DWORD dwCreationDisposition, __in DWORD dwFlagsAndAttributes, __in HANDLE hTemplateFile);
typedef BOOL (WINAPI *WRITEFILE)(__in HANDLE hFile, __in LPCVOID lpBuffer, __in DWORD nNumberOfBytesToWrite, __out LPDWORD lpNumberOfBytesWritten, __in LPOVERLAPPED lpOverlapped);
typedef UINT (WINAPIV *WTOI)(__in LPWSTR string);
typedef UINT(WINAPIV *ATOI)(LPSTR string);
typedef BOOL (WINAPI *GETUSERPROFILEDIRECTORYW)(__in HANDLE hToken, __out LPWSTR lpProfileDir, __in LPDWORD lpcchSize);
typedef BOOL (WINAPI *OPENPROCESSTOKEN)(__in HANDLE ProcessHandle, __in DWORD DesiredAccess, __out PHANDLE TokenHandle);
typedef BOOL (WINAPI *DELETEFILEA)(__in LPSTR strFileName);
typedef BOOL (WINAPI *FREELIBRARY)(__in HMODULE hMod);
typedef DWORD (WINAPI *WCSTOMBS)(__inout LPSTR lpStr, __in LPWSTR lpWstr, __in DWORD count);
typedef HANDLE (WINAPI *CREATETHREAD)(__in LPSECURITY_ATTRIBUTES lpThreadAttributes, __in SIZE_T dwStackSize, __in LPTHREAD_START_ROUTINE lpStartAddress, __in LPVOID lpParameter, __in DWORD dwCreationFlags, __out LPDWORD lpThreadId);
typedef DWORD (WINAPI *WAITFORSINGLEOBJECT)(__in HANDLE hHandle, __in DWORD dwMilliseconds);
typedef BOOL (WINAPI *TERMINATETHREAD)(__in HANDLE hThread, __in DWORD dwExitCode);
typedef BOOL (WINAPI *CLOSEHANDLE)(__in HANDLE hFile);
typedef BOOL (WINAPI *GETTEMPPATHW)(__in DWORD nBufferLength, __out LPWSTR lpBuffer);
typedef BOOL (WINAPI *SHGETKNOWNFOLDERPATH)(__in REFKNOWNFOLDERID rfid, __in DWORD dwFlags, __in HANDLE hToken, __out LPWSTR *ppszPath);
typedef BOOL (WINAPI *DELETEFILEW)(__in LPWSTR lpFileName);
typedef DWORD (WINAPI *GETFILESIZE)(_In_ HANDLE hFile, _Out_opt_  LPDWORD lpFileSizeHigh);
typedef HANDLE (WINAPI *CREATEFILEMAPPINGA)(_In_ HANDLE hFile, _In_opt_  LPSECURITY_ATTRIBUTES lpAttributes,  _In_      DWORD flProtect,  _In_      DWORD dwMaximumSizeHigh,  _In_ DWORD dwMaximumSizeLow,  _In_opt_  LPSTR lpName);
typedef LPVOID (WINAPI *MAPVIEWOFFILE)(_In_  HANDLE hFileMappingObject,_In_  DWORD dwDesiredAccess, _In_  DWORD dwFileOffsetHigh,  _In_  DWORD dwFileOffsetLow,  _In_  SIZE_T dwNumberOfBytesToMap);
typedef BOOL (WINAPI *SETENDOFFILE)( _In_  HANDLE hFile);
typedef BOOL (WINAPI *UNMAPVIEWOFFILE)(_In_  LPCVOID lpBaseAddress);
typedef DWORD (WINAPI *SETFILEPOINTER)(_In_ HANDLE hFile, _In_ LONG lDistanceToMove,_Inout_opt_  PLONG lpDistanceToMoveHigh, _In_ DWORD dwMoveMethod);
typedef DWORD (WINAPI *FORMATMESSAGE)(_In_      DWORD dwFlags, _In_opt_  LPCVOID lpSource, _In_  DWORD dwMessageId, _In_  DWORD dwLanguageId,_Out_   LPSTR lpBuffer,  _In_      DWORD nSize,  _In_opt_  va_list *Arguments);
typedef DWORD (WINAPI *GETLASTERROR)(void);
typedef HANDLE (WINAPI *OPENPROCESS)(DWORD dwDesiredAccess,BOOL bInheritHandle,DWORD dwProcessId);

typedef HANDLE (WINAPI *GETCURRENTPROCESS)(VOID);
typedef BOOL (WINAPI *DUPLICATEHANDLE)(  HANDLE hSourceProcessHandle,    HANDLE hSourceHandle,     HANDLE hTargetProcessHandle,    LPHANDLE lpTargetHandle,     DWORD dwDesiredAccess,     BOOL bInheritHandle,     DWORD dwOptions);
typedef DWORD (WINAPI *GETCURRENTPROCESSID)(void);

#define TH32CS_SNAPPROCESS 0x2
typedef struct tagPROCESSENTRY32 {
	DWORD     dwSize;
	DWORD     cntUsage;
	DWORD     th32ProcessID;
	ULONG_PTR th32DefaultHeapID;
	DWORD     th32ModuleID;
	DWORD     cntThreads;
	DWORD     th32ParentProcessID;
	LONG      pcPriClassBase;
	DWORD     dwFlags;
	TCHAR     szExeFile[MAX_PATH];
} PROCESSENTRY32, *LPPROCESSENTRY32;


typedef HANDLE (WINAPI *CREATETOOLHELP32SNAPSHOT)(DWORD dwFlags, DWORD th32ProcessID);
typedef BOOL (WINAPI *PROCESS32FIRST)(HANDLE hSnapshot, LPPROCESSENTRY32 lppe);
typedef BOOL (WINAPI *PROCESS32NEXT)(HANDLE hSnapshot, LPPROCESSENTRY32 lppe);

typedef VOID   (WINAPI *OUTPUTDEBUGSTRINGA)(__in  LPCTSTR lpOutputString);
typedef DWORD  (WINAPI *WAITFORSINGLEOBJECT)(_In_  HANDLE hHandle,_In_  DWORD dwMilliseconds);

typedef HINTERNET(WINAPI *INTERNETCONNECTA)(HINTERNET hInternet, LPCTSTR lpszServerName, INTERNET_PORT nServerPort, LPCTSTR lpszUsername, LPCTSTR lpszPassword, DWORD dwService, DWORD dwFlags, DWORD_PTR dwContext);
typedef HINTERNET(WINAPI *HTTPOPENREQUESTA)(HINTERNET hConnect, LPCTSTR lpszVerb, LPCTSTR lpszObjectName, LPCTSTR lpszVersion, LPCTSTR lpszReferer, LPCTSTR *lplpszAcceptTypes, DWORD dwFlags, DWORD_PTR dwContext);
typedef BOOL(WINAPI *INTERNETQUERYOPTION)(HINTERNET hInternet, DWORD dwOption, LPVOID lpBuffer, LPDWORD lpdwBufferLength);
typedef BOOL(WINAPI *INTERNETSETOPTION)(HINTERNET hInternet, DWORD dwOption, LPVOID lpBuffer, DWORD dwBufferLength);
typedef BOOL(WINAPI *HTTPSENDREQUEST)(HINTERNET hRequest, LPCTSTR lpszHeaders, DWORD dwHeadersLength, LPVOID lpOptional, DWORD dwOptionalLength);
typedef BOOL(WINAPI *INTERNETCLOSEHANDLE)(HINTERNET hInternet);

typedef void *(__cdecl *MALLOC)(size_t size);
typedef void *(__cdecl *CALLOC)(size_t num, size_t size );
typedef void (__cdecl *FREE)(void *ptr);
typedef int (__cdecl *SPRINTF)(char *str, const char *format, ...);

typedef ULONGLONG (WINAPI *VERSETCONDITIONMASK)(  ULONGLONG dwlConditionMask,   DWORD dwTypeBitMask,   BYTE dwConditionMask);
typedef BOOL (WINAPI *VERIFYVERSIONINFOA)(  LPOSVERSIONINFOEX lpVersionInfo,   DWORD dwTypeMask,   DWORDLONG dwlConditionMask);

#endif // _WINAPI_H